apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ console_name }}
  name: {{ console_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ console_replicas }}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ console_name }}
  strategy:
    type: RollingUpdate
{% else %}
    name: {{ console_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Rolling
{% endif %}
  template:
    metadata:
      labels:
        name: {{ console_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ console_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ console_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      containers:
      - env:
{% if (airbrake_id | default(False)) and (airbrake_key | default(False)) %}
        - name: AIRBRAKE_ID
          valueFrom:
            secretKeyRef:
              key: airbrake-id
              name: {{ admin_name }}-airbrake
        - name: AIRBRAKE_KEY
          valueFrom:
            secretKeyRef:
              key: airbrake-key
              name: {{ admin_name }}-airbrake
{% if airbrake_host | default(False) %}
        - name: AIRBRAKE_HOST
          valueFrom:
            secretKeyRef:
              key: airbrake-host
              name: {{ admin_name }}-airbrake
{% endif %}
{% else %}
        - name: AIRBRAKE_ID
          value: ""
        - name: AIRBRAKE_KEY
          value: ""
{% endif %}
        - name: CONSOLE_API_HOSTNAME
          value: console-{{ namespace }}.{{ root_domain }}
        - name: CONSOLE_API_HTTP_PORT
          value: '8080'
        - name: CONSOLE_API_HTTP_PROTO
          value: https
        - name: CONSOLE_API_PUB_PORT
          value: '443'
        - name: CONSOLE_BIND_ADDR
          value: 0.0.0.0
        - name: NODE_ENV
          value: production
        - name: NODE_TLS_REJECT_UNAUTHORIZED
          value: '0'
        - name: OPENSHIFT_ENDPOINT
          value: kubernetes.default.svc.{{ cluster_domain }}
        - name: OPENSHIFT_NAMESPACE
          value: {{ buildns }}
        - name: OPENSHIFT_SA
          value: "system:serviceaccount:{{ namespace }}:{{ console_name }}"
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='wsweetconsole'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='wsweetconsole'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 20
          httpGet:
            path: /ping
            port: 8080
          initialDelaySeconds: 30
          periodSeconds: 10
          timeoutSeconds: 5
        name: console
        ports:
        - containerPort: 8080
        readinessProbe:
          httpGet:
            path: /ping
            port: 8080
          initialDelaySeconds: 20
          periodSeconds: 10
          timeoutSeconds: 3
        resources:
          limits:
            cpu: "{{ console_cpu_limit }}"
            memory: "{{ console_memory_limit }}"
          requests:
            cpu: "{{ console_cpu_request }}"
            memory: "{{ console_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
      serviceAccountName: {{ console_name }}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ console_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='wsweetconsole'].short"))[0] %}
  - imageChangeParams:
      automatic: true
      containerNames:
      - console
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='wsweetconsole'].short"))[0] }}
        namespace: {{ buildns }}
    type: ImageChange
{% endif %}
  - type: ConfigChange
{% endif %}
